package com.example.ueberwachungssystem;

import static android.content.ContentValues.TAG;

import android.annotation.SuppressLint;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.IBinder;
import android.util.Log;
import android.view.MenuItem;
import android.widget.Toast;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.camera.core.ExperimentalGetImage;

import com.example.ueberwachungssystem.Detection.DetectionReport;
import com.example.ueberwachungssystem.Detection.DetectorService;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@ExperimentalGetImage
public class MainActivity extends AppCompatActivity {

    WifiCommunication communication;
    PermissionRequest permission;
    boolean communicationRunning = true;
    TextView textview1;

    private DetectorService detectorService = new DetectorService();

        @Override
        protected void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            setContentView(R.layout.activity_main);

            Intent serviceIntent = new Intent(this, DetectorService.class);
            bindService(serviceIntent, serviceConnection, Context.BIND_AUTO_CREATE);
            startService(serviceIntent);
            //textview1 = findViewById(R.id.textView1);

            //Button button1 = findViewById(R.id.buttonSend);
            /*button1.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    communication.sendTrue("Testmessage");
                }
            });*/
        }

        private ServiceConnection serviceConnection = new ServiceConnection() {
            @Override
            public void onServiceConnected(ComponentName name, IBinder service) {
                DetectorService.ServiceBinder binder = (DetectorService.ServiceBinder) service;
                detectorService = binder.getBoundService();

                detectorService.setOnDetectionListener(new DetectorService.OnDetectionListener() {
                    @Override
                    public void onDetection(StringBuffer stringBuffer) {
                        //textview für oli
                        Log.d("Debugger", stringBuffer.toString());
                    }
                });
            }

            @Override
            public void onServiceDisconnected(ComponentName name) {

            }
        };
    @Override
    protected void onResume() {
        super.onResume();
        if (communicationRunning){
            communication = new WifiCommunication(1234);
            communication.setOnConnectionListener(new WifiCommunication.OnConnectionListener() {
                @Override
                public void onConnection(String data) {
                    //Log.d("Test", data.toString());
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            textview1.setText(data);
                        }
                    });
                }
            });
            communicationRunning = false;
        }
        permission = new PermissionRequest(MainActivity.this);
        permission.rechtePruefen();
        }

    @Override
    protected void onPause() {
        super.onPause();
        //communication.stopCommunication();
    }
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.options_menu, menu);
        return true;
    }
    /*public boolean onOptionsItemSelected(MenuItem item) {
        Toast.makeText(this, "Selected Item: " + item.getTitle(), Toast.LENGTH_SHORT).show();
        PopUpClass popUpClass;
        switch (item.getItemId()) {
            case R.id.Rechteverwaltung:
                popUpClass = new PopUpClass(MainActivity.this);
                popUpClass.showPopupWindow(textview1);
                popUpClass.RechtePrüfen();
                return true;
            case R.id.Sensoren:
                popUpClass = new PopUpClass(MainActivity.this);
                popUpClass.showPopupWindow(textview1);
                popUpClass.Sensoren();
                return true;
            case R.id.Impressum:
                popUpClass = new PopUpClass(MainActivity.this);
                popUpClass.showPopupWindow(textview1);
                popUpClass.Impressum();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }*/

}

